----------------------------------------------------------------------------------
-- Company: 
-- Engineer: 
-- 
-- Create Date:    17:42:01 07/30/2014 
-- Design Name: 
-- Module Name:    RHA_TESTVALUE_GENERATOR - Behavioral 
-- Project Name: 
-- Target Devices: 
-- Tool versions: 
-- Description: 
--
-- Dependencies: 
--
-- Revision: 
-- Revision 0.01 - File Created
-- Additional Comments: 
--
----------------------------------------------------------------------------------
library IEEE;

use IEEE.std_logic_1164.all;
use IEEE.numeric_std.all;

entity RHA_TESTVALUE_GENERATOR is
    Port ( 
				TESTVALUE_0_OUT : out STD_LOGIC_VECTOR(24 downto 0);	 
				TESTVALUE_1_OUT : out STD_LOGIC_VECTOR(24 downto 0);	 
				TESTVALUE_2_OUT : out STD_LOGIC_VECTOR(24 downto 0);	 
				TESTVALUE_3_OUT : out STD_LOGIC_VECTOR(24 downto 0);	 
				TESTVALUE_4_OUT : out STD_LOGIC_VECTOR(24 downto 0);	 
				TESTVALUE_5_OUT : out STD_LOGIC_VECTOR(24 downto 0);	 
				TESTVALUE_6_OUT : out STD_LOGIC_VECTOR(24 downto 0);	 
				TESTVALUE_7_OUT : out STD_LOGIC_VECTOR(24 downto 0);	 
				
				LAST_CHANNEL : out STD_LOGIC;
				
				NextValue	: in  STD_LOGIC;
				
				Clk 			: in  STD_LOGIC;
				Reset 		: in  STD_LOGIC
			);
end RHA_TESTVALUE_GENERATOR;

architecture Behavioral of RHA_TESTVALUE_GENERATOR is
	
	signal DATAOUT_ADDRESS		: STD_LOGIC_VECTOR(4 downto 0) := (others => '0');
	signal DATAOUT_ADDRESS_R	: STD_LOGIC_VECTOR(4 downto 0) := (others => '0');
	signal Channel_Number		: STD_LOGIC_VECTOR(3 downto 0) := (others => '0');
	signal Channel_Counter		: unsigned(3 downto 0) := (others => '0');
	
	signal Sample_Number			: STD_LOGIC_VECTOR(8 downto 0) := (others => '0');
	signal Sample_Counter		: unsigned(8 downto 0) := (others => '0');
	
	constant HEADER				: STD_LOGIC_VECTOR(2 downto 0) := "011";
	signal XOR_SAMPLE				: STD_LOGIC := '0';
	signal XOR_CHANNEL_NUMBER  		: STD_LOGIC := '0';
	signal XOR_ADDRESS  			: STD_LOGIC := '0';
	signal XOR_HEADER				: STD_LOGIC := '0';
	signal XOR_GLOBAL				: STD_LOGIC := '0';
	
	signal PARITY_0 				: STD_LOGIC := '0';
	signal PARITY_1 				: STD_LOGIC := '0';
	signal PARITY_2 				: STD_LOGIC := '0';
	signal PARITY_3 				: STD_LOGIC := '0';
	signal PARITY_4 				: STD_LOGIC := '0';
	signal PARITY_5 				: STD_LOGIC := '0';
	signal PARITY_6 				: STD_LOGIC := '0';
	signal PARITY_7 				: STD_LOGIC := '0';
	

	
	signal NextValue_LAST 		: STD_LOGIC := '0';
	signal LAST_CHANNEL_INTERNAL : STD_LOGIC := '0';


	signal TESTVALUE_0_OUT_BUFFER : STD_LOGIC_VECTOR(24 downto 0) := (others => '0');	 
	signal TESTVALUE_1_OUT_BUFFER : STD_LOGIC_VECTOR(24 downto 0) := (others => '0');	 
	signal TESTVALUE_2_OUT_BUFFER : STD_LOGIC_VECTOR(24 downto 0) := (others => '0');	 
	signal TESTVALUE_3_OUT_BUFFER : STD_LOGIC_VECTOR(24 downto 0) := (others => '0');	 
	signal TESTVALUE_4_OUT_BUFFER : STD_LOGIC_VECTOR(24 downto 0) := (others => '0');	 
	signal TESTVALUE_5_OUT_BUFFER : STD_LOGIC_VECTOR(24 downto 0) := (others => '0');	 
	signal TESTVALUE_6_OUT_BUFFER : STD_LOGIC_VECTOR(24 downto 0) := (others => '0');	 
	signal TESTVALUE_7_OUT_BUFFER : STD_LOGIC_VECTOR(24 downto 0) := (others => '0');	

	signal TESTVALUE_0 : STD_LOGIC_VECTOR(24 downto 0) := (others => '0');	 
	signal TESTVALUE_1 : STD_LOGIC_VECTOR(24 downto 0) := (others => '0');	 
	signal TESTVALUE_2 : STD_LOGIC_VECTOR(24 downto 0) := (others => '0');	 
	signal TESTVALUE_3 : STD_LOGIC_VECTOR(24 downto 0) := (others => '0');	 
	signal TESTVALUE_4 : STD_LOGIC_VECTOR(24 downto 0) := (others => '0');	 
	signal TESTVALUE_5 : STD_LOGIC_VECTOR(24 downto 0) := (others => '0');	 
	signal TESTVALUE_6 : STD_LOGIC_VECTOR(24 downto 0) := (others => '0');	 
	signal TESTVALUE_7 : STD_LOGIC_VECTOR(24 downto 0) := (others => '0');	


begin
	
	TESTVALUE_0_OUT <= TESTVALUE_0_OUT_BUFFER;
	TESTVALUE_1_OUT <= TESTVALUE_1_OUT_BUFFER;
	TESTVALUE_2_OUT <= TESTVALUE_2_OUT_BUFFER;
	TESTVALUE_3_OUT <= TESTVALUE_3_OUT_BUFFER;
	TESTVALUE_4_OUT <= TESTVALUE_4_OUT_BUFFER;
	TESTVALUE_5_OUT <= TESTVALUE_5_OUT_BUFFER;
	TESTVALUE_6_OUT <= TESTVALUE_6_OUT_BUFFER;
	TESTVALUE_7_OUT <= TESTVALUE_7_OUT_BUFFER;


	Channel_Number <= std_logic_vector(Channel_Counter);
	Sample_Number <= std_logic_vector(Sample_Counter);

	DATAOUT_ADDRESS_R(4) <= DATAOUT_ADDRESS(0);
	DATAOUT_ADDRESS_R(3) <= DATAOUT_ADDRESS(1);
	DATAOUT_ADDRESS_R(2) <= DATAOUT_ADDRESS(2);
	DATAOUT_ADDRESS_R(1) <= DATAOUT_ADDRESS(3);
	DATAOUT_ADDRESS_R(0) <= DATAOUT_ADDRESS(4);

	TESTVALUE_0 <= PARITY_0 & CHANNEL_ID_0 & Channel_Number & Sample_Number & DATAOUT_ADDRESS_R & HEADER;
	TESTVALUE_1 <= PARITY_1 & CHANNEL_ID_1 & Channel_Number & Sample_Number & DATAOUT_ADDRESS_R & HEADER;
	TESTVALUE_2 <= PARITY_2 & CHANNEL_ID_2 & Channel_Number & Sample_Number & DATAOUT_ADDRESS_R & HEADER;
	TESTVALUE_3 <= PARITY_3 & CHANNEL_ID_3 & Channel_Number & Sample_Number & DATAOUT_ADDRESS_R & HEADER;
	TESTVALUE_4 <= PARITY_4 & CHANNEL_ID_4 & Channel_Number & Sample_Number & DATAOUT_ADDRESS_R & HEADER;
	TESTVALUE_5 <= PARITY_5 & CHANNEL_ID_5 & Channel_Number & Sample_Number & DATAOUT_ADDRESS_R & HEADER;
	TESTVALUE_6 <= PARITY_6 & CHANNEL_ID_6 & Channel_Number & Sample_Number & DATAOUT_ADDRESS_R & HEADER;
	TESTVALUE_7 <= PARITY_7 & CHANNEL_ID_7 & Channel_Number & Sample_Number & DATAOUT_ADDRESS_R & HEADER;

	-- PARITY
	XOR_SAMPLE <= Sample_Number(8) XOR Sample_Number(7) XOR Sample_Number(6) XOR Sample_Number(5) XOR Sample_Number(4) XOR
		Sample_Number(3) XOR Sample_Number(2) XOR Sample_Number(1) XOR Sample_Number(0);

	XOR_CHANNEL_NUMBER <= Channel_Number(3) XOR Channel_Number(2) XOR Channel_Number(1) XOR Channel_Number(0);

	XOR_GLOBAL <= XOR_CHANNEL_NUMBER XOR XOR_SAMPLE ;

	PARITY_0 <= NOT ( CHANNEL_ID_0(2) XOR CHANNEL_ID_0(1) XOR CHANNEL_ID_0(0) XOR XOR_GLOBAL);
	PARITY_1 <= NOT ( CHANNEL_ID_1(2) XOR CHANNEL_ID_1(1) XOR CHANNEL_ID_1(0) XOR XOR_GLOBAL);
	PARITY_2 <= NOT ( CHANNEL_ID_2(2) XOR CHANNEL_ID_2(1) XOR CHANNEL_ID_2(0) XOR XOR_GLOBAL);
	PARITY_3 <= NOT ( CHANNEL_ID_3(2) XOR CHANNEL_ID_3(1) XOR CHANNEL_ID_3(0) XOR XOR_GLOBAL);
	PARITY_4 <= NOT ( CHANNEL_ID_4(2) XOR CHANNEL_ID_4(1) XOR CHANNEL_ID_4(0) XOR XOR_GLOBAL);
	PARITY_5 <= NOT ( CHANNEL_ID_5(2) XOR CHANNEL_ID_5(1) XOR CHANNEL_ID_5(0) XOR XOR_GLOBAL);
	PARITY_6 <= NOT ( CHANNEL_ID_6(2) XOR CHANNEL_ID_6(1) XOR CHANNEL_ID_6(0) XOR XOR_GLOBAL);
	PARITY_7 <= NOT ( CHANNEL_ID_7(2) XOR CHANNEL_ID_7(1) XOR CHANNEL_ID_7(0) XOR XOR_GLOBAL);

	LAST_CHANNEL <= LAST_CHANNEL_INTERNAL;
	
	Counter_Process : process (Clk,Reset)
	begin
		if Reset = '1' then
			Channel_Counter <= (others => '0');			 
			Sample_Counter <= (others => '0');
			LAST_CHANNEL_INTERNAL <= '0';

			TESTVALUE_0_OUT_BUFFER <= (others => '0');
			TESTVALUE_1_OUT_BUFFER <= (others => '0');
			TESTVALUE_2_OUT_BUFFER <= (others => '0');
			TESTVALUE_3_OUT_BUFFER <= (others => '0');
			TESTVALUE_4_OUT_BUFFER <= (others => '0');
			TESTVALUE_5_OUT_BUFFER <= (others => '0');
			TESTVALUE_6_OUT_BUFFER <= (others => '0');
			TESTVALUE_7_OUT_BUFFER <= (others => '0');

		elsif rising_edge(Clk) then
			TESTVALUE_0_OUT_BUFFER <= TESTVALUE_0;
			TESTVALUE_1_OUT_BUFFER <= TESTVALUE_1;
			TESTVALUE_2_OUT_BUFFER <= TESTVALUE_2;
			TESTVALUE_3_OUT_BUFFER <= TESTVALUE_3;
			TESTVALUE_4_OUT_BUFFER <= TESTVALUE_4;
			TESTVALUE_5_OUT_BUFFER <= TESTVALUE_5;
			TESTVALUE_6_OUT_BUFFER <= TESTVALUE_6;
			TESTVALUE_7_OUT_BUFFER <= TESTVALUE_7;

			LAST_CHANNEL_INTERNAL <= LAST_CHANNEL_INTERNAL;
			
			if (NextValue_LAST = '0') AND (NextValue = '1') AND (Channel_Counter = to_unsigned(15,4)) then
				Channel_Counter <= (others => '0');
				Sample_Counter <= Sample_Counter + 1;
				LAST_CHANNEL_INTERNAL <= '0';
			elsif (NextValue_LAST = '0') AND (NextValue = '1') AND (Channel_Counter = to_unsigned(14,4)) then
				Channel_Counter <= Channel_Counter + 1;
				Sample_Counter <= Sample_Counter;
				LAST_CHANNEL_INTERNAL <= '1';
			elsif (NextValue_LAST = '0') AND (NextValue = '1') then 
				Channel_Counter <= Channel_Counter + 1;
				Sample_Counter <= Sample_Counter;
				LAST_CHANNEL_INTERNAL <= '0';
			else
				Channel_Counter <= Channel_Counter;
				Sample_Counter <= Sample_Counter;
			end if;
		end if;
	end process Counter_Process;

	
	PatternAddress : process (Channel_Number)
	begin

		case Channel_Number is

			-- 0
			when "0000" => 
				DATAOUT_ADDRESS <= "01000";
			-- 1
			when "0001" => 
				DATAOUT_ADDRESS <= "01001";
			-- 2
			when "0010" => 
				DATAOUT_ADDRESS <= "01010";
			-- 3
			when "0011" => 
				DATAOUT_ADDRESS <= "01011";
			-- 4
			when "0100" => 
				DATAOUT_ADDRESS <= "01100";
			-- 5
			when "0101" => 
				DATAOUT_ADDRESS <= "01101";
			-- 6
			when "0110" => 
				DATAOUT_ADDRESS <= "01110";
			-- 7
			when "0111" => 
				DATAOUT_ADDRESS <= "01111";
			-- 8
			when "1000" => 
				DATAOUT_ADDRESS <= "10000";
			-- 9
			when "1001" => 
				DATAOUT_ADDRESS <= "10001";
			-- 10
			when "1010" => 
				DATAOUT_ADDRESS <= "10010";
			-- 11
			when "1011" => 
				DATAOUT_ADDRESS <= "10011";
			-- 12
			when "1100" => 
				DATAOUT_ADDRESS <= "10100";
			-- 13
			when "1101" => 
				DATAOUT_ADDRESS <= "10101";
			-- 14
			when "1110" =>
				DATAOUT_ADDRESS <= "10110";
			-- 15
			when "1111" => 
				DATAOUT_ADDRESS <= "10111";
			when others => 
				DATAOUT_ADDRESS <= "00000";
		end case;

	end process PatternAddress;

end Behavioral;

