--------------------------------------------------------------------------------
-- Company: <Name>
--
-- File: IGLOO_TOP.vhd
-- File history:
--      <Revision number>: <Date>: <Comments>
--      <Revision number>: <Date>: <Comments>
--      <Revision number>: <Date>: <Comments>
--
-- Description: 
--
-- <Description here>
--
-- Targeted device: <Family::IGLOO> <Die::AGL250V2> <Package::100 VQFP>
-- Author: <Name>
--
--------------------------------------------------------------------------------
library IEEE;

use IEEE.std_logic_1164.all;
use IEEE.numeric_std.all;

entity IGLOO_TOP is
port (
	 		-- Connection to the Zarlink 
		SPI_ZL_CS 						: out STD_LOGIC;
		SPI_SDI 						: out STD_LOGIC;
		SPI_SDO 						: in  STD_LOGIC;
		SPI_CLK 						: out STD_LOGIC;

		RHD_MOSI 						: out STD_LOGIC_VECTOR(7 downto 0);
		RHD_MISO						: in  STD_LOGIC_VECTOR(7 downto 0);
		RHD_CLK							: out STD_LOGIC_VECTOR(7 downto 0);
		RHD_CS							: out STD_LOGIC_VECTOR(7 downto 0);
		
--		DEBUG_STRING_ORGANIZER			: out std_logic_vector (3 downto 0);
--		DEBUG_ProcessOngoing			: out std_logic;
--		DEBUG_ProcessParameter			: out std_logic;

		Reset 							: in  STD_LOGIC;				
		Clk 							: in  STD_LOGIC
);
end IGLOO_TOP;
architecture IGLOO_TOP_ARCH of IGLOO_TOP is

begin


	MYImplant : entity work.IMPLANT_TOP
    Port MAP ( 
	 		-- Connection to the Zarlink 
		SPI_ZL_CS => SPI_ZL_CS,
		SPI_SDI => SPI_SDI,
		SPI_SDO => SPI_SDO,
		SPI_CLK => SPI_CLK,

		RHD_MOSI => RHD_MOSI,
		RHD_MISO => RHD_MISO,
		RHD_Clk	=> RHD_Clk,
		RHD_CS => RHD_CS,
	
		-- Debugging the Zarlink 
--		DEBUG_ZARLINK_DATA => open,
--		DEBUG_ZARLINK_VALID	=> open,

		-- Error flags 
		ERROR_ALL_OUT => open,
--		DEBUG_STRING_ORGANIZER => DEBUG_STRING_ORGANIZER,
--		DEBUG_ProcessOngoing => DEBUG_ProcessOngoing,
--		DEBUG_ProcessParameter => DEBUG_ProcessParameter,


		-- The usual ports 
		Reset => NOT Reset,
		Clk_FAST => Clk

	 );

   -- architecture body
end IGLOO_TOP_ARCH;
