----------------------------------------------------------------------------------
-- Company: 
-- Engineer: 
-- 
-- Create Date:    18:14:56 07/23/2014 
-- Design Name: 
-- Module Name:    IMPLANT_TOP - Behavioral 
-- Project Name: 
-- Target Devices: 
-- Tool versions: 
-- Description: 
--
-- Dependencies: 
--
-- Revision: 
-- Revision 0.01 - File Created
-- Additional Comments: 
--
----------------------------------------------------------------------------------
library IEEE;

use IEEE.std_logic_1164.all;
use IEEE.numeric_std.all;

entity IMPLANT_TOP is
    Port ( 
	 		-- Connection to the Zarlink 
		SPI_ZL_CS 				: out STD_LOGIC;
		SPI_SDI 				: out STD_LOGIC;
		SPI_SDO 				: in  STD_LOGIC;
		SPI_CLK 				: out STD_LOGIC;		

		-- For the data stream
		RHD_MOSI 				: out STD_LOGIC_VECTOR(7 downto 0);
		RHD_MISO				: in  STD_LOGIC_VECTOR(7 downto 0);
		RHD_Clk					: out STD_LOGIC_VECTOR(7 downto 0);
		RHD_CS					: out STD_LOGIC_VECTOR(7 downto 0);
	
--		-- Debugging the Zarlink 
--		DEBUG_ZARLINK_DATA		: out STD_LOGIC_VECTOR(15 downto 0);
--		DEBUG_ZARLINK_VALID		: out STD_LOGIC;
--
--		-- DEBUG
--		DEBUG_GetCommand_DATA		: out STD_LOGIC_VECTOR(7 downto 0);
--		DEBUG_GetCommand_VALID		: out STD_LOGIC;		
--
--		-- Parameters
--		DEBUG_ChannelMask_00   			: out  std_logic_vector( 31 downto 0);
--		DEBUG_ChannelMask_01   			: out  std_logic_vector( 31 downto 0);
--		DEBUG_ChannelMask_02   			: out  std_logic_vector( 31 downto 0);
--		DEBUG_ChannelMask_03   			: out  std_logic_vector( 31 downto 0);
--		DEBUG_ChannelMask_04   			: out  std_logic_vector( 31 downto 0);
--		DEBUG_ChannelMask_05   			: out  std_logic_vector( 31 downto 0);
--		DEBUG_ChannelMask_06   			: out  std_logic_vector( 31 downto 0);
--		DEBUG_ChannelMask_07   			: out  std_logic_vector( 31 downto 0);
--		DEBUG_ChannelMask_Changed		: out  std_logic;
--		DEBUG_AuxMask_00					: out  std_logic_vector( 2 downto 0);
--		DEBUG_AuxMask_01					: out  std_logic_vector( 2 downto 0);
--		DEBUG_AuxMask_02					: out  std_logic_vector( 2 downto 0);
--		DEBUG_AuxMask_03					: out  std_logic_vector( 2 downto 0);
--		DEBUG_AuxMask_04					: out  std_logic_vector( 2 downto 0);
--		DEBUG_AuxMask_05					: out  std_logic_vector( 2 downto 0);
--		DEBUG_AuxMask_06					: out  std_logic_vector( 2 downto 0);
--		DEBUG_AuxMask_07					: out  std_logic_vector( 2 downto 0);
--		DEBUG_AuxMask_Changed			: out  std_logic;
--		DEBUG_RHD_COMMAND_DATA 			: out  std_logic_vector( 15 downto 0);
--		DEBUG_RHD_COMMAND_VALID 		: out  std_logic_vector(7 downto 0);		
--		DEBUG_SampleRate      			: out  std_logic_vector(31 downto 0);
--		DEBUG_SampleRate_Changed		: out  std_logic;
--		DEBUG_TestMode						: out STD_LOGIC;
--		DEBUG_TestMode_Changed			: out STD_LOGIC;
--		DEBUG_WorkMode						: out STD_LOGIC;
--		DEBUG_WorkMode_Changed			: out STD_LOGIC;
--		DEBUG_BITMASK_SAMPLE				: out  std_logic_vector(15 downto 0);			 
--		DEBUG_BITMASK_SAMPLE_Changed	: out  std_logic;		
--
--		DEBUG_FIFO_OUT_DATA 				: out  std_logic_vector(7 downto 0);
--		DEBUG_FIFO_OUT_VALID 			: out STD_LOGIC;
--
--		DEBUG_FIFO_ZL_DATA 				: out  std_logic_vector(7 downto 0);
--		
--		DEBUG_CheckOutgoingBuffer 		: out std_logic_vector (6 downto 0);		
--		
--		DEBUG_FIFO_ZL_VALID 				: out STD_LOGIC;
		-- Error flags 
		ERROR_ALL_OUT 						: out STD_LOGIC;

--		DEBUG_STRING_ORGANIZER		: out std_logic_vector (3 downto 0);
--		DEBUG_ProcessOngoing		: out std_logic;
--		DEBUG_ProcessParameter		: out std_logic;
	
		-- The usual ports 
		Reset 						: in  STD_LOGIC;				
		Clk_FAST					: in  STD_LOGIC

	 );
end IMPLANT_TOP;

architecture Behavioral of IMPLANT_TOP is

		-- Parameters
		signal ChannelMask_00   		: std_logic_vector( 31 downto 0) := (others => '0');
		signal ChannelMask_01   		: std_logic_vector( 31 downto 0) := (others => '0');
		signal ChannelMask_02   		: std_logic_vector( 31 downto 0) := (others => '0');
		signal ChannelMask_03   		: std_logic_vector( 31 downto 0) := (others => '0');
		signal ChannelMask_04   		: std_logic_vector( 31 downto 0) := (others => '0');
		signal ChannelMask_05   		: std_logic_vector( 31 downto 0) := (others => '0');
		signal ChannelMask_06   		: std_logic_vector( 31 downto 0) := (others => '0');
		signal ChannelMask_07   		: std_logic_vector( 31 downto 0) := (others => '0');
		signal ChannelMask_Changed		: std_logic := '0';

		signal AuxMask_00					: std_logic_vector( 2 downto 0) := (others => '0');
		signal AuxMask_01					: std_logic_vector( 2 downto 0) := (others => '0');
		signal AuxMask_02					: std_logic_vector( 2 downto 0) := (others => '0');
		signal AuxMask_03					: std_logic_vector( 2 downto 0) := (others => '0');
		signal AuxMask_04					: std_logic_vector( 2 downto 0) := (others => '0');
		signal AuxMask_05					: std_logic_vector( 2 downto 0) := (others => '0');
		signal AuxMask_06					: std_logic_vector( 2 downto 0) := (others => '0');
		signal AuxMask_07					: std_logic_vector( 2 downto 0) := (others => '0');
		signal AuxMask_Changed			: std_logic := '0';
		
		-- Command to RHD
		signal RHD_COMMAND_DATA 		: std_logic_vector( 15 downto 0) := (others => '0');
		signal RHD_COMMAND_VALID 		: std_logic_vector(7 downto 0) := (others => '0');
		
		-- We also need a variable clock that is looking on this SampleRate
		signal SampleRate      			: std_logic_vector(31 downto 0) := (others => '0');
		signal SampleRate_Changed		: std_logic := '0';

		-- RHD TEST MODE GENATOR (ON/OFF)
		signal TestMode					: STD_LOGIC := '0';
		signal TestMode_Changed			: STD_LOGIC := '0';
		
		-- Work MODE DATA ACQUISITION(ON/OFF)
		signal WorkMode					: STD_LOGIC := '0';
		signal NOTWorkMode				: STD_LOGIC := '0';
		signal WorkMode_Changed			: STD_LOGIC := '0';
		
		signal DeviceID        			: std_logic_vector(7 downto 0) := (others => '0');		

		-- Bitmask for the data selection from the 16 bit samples.
		signal BITMASK_SAMPLE			: std_logic_vector(15 downto 0) := (others => '0');			 
		signal BITMASK_SAMPLE_Changed	: std_logic := '0';
		
		signal WAIT_PROCESS_PARAMETER	: std_logic := '0';
		
		-- Connection to the RHA DATA FIFO...
		signal FIFO_IN_DATA				: STD_LOGIC_VECTOR(7 downto 0) := (others => '0');	
		signal FIFO_IN_VALID				: STD_LOGIC := '0';
		signal FIFO_IN_READENABLE		: STD_LOGIC := '0';

		-- This goes into the Zarlink / FIFO direction: 
		signal FIFO_OUT_DATA   				: STD_LOGIC_VECTOR(7 downto 0) := (others => '0');
		signal FIFO_OUT_VALID   			: STD_LOGIC := '0';
		-- We need the FIFO to have (at least)
		-- 21 x 112 bit (2352 its)
		-- of free space for the next block to be on the safe side.		
		signal ExportNext280ChannelBlock	: STD_LOGIC := '0';

		-- 32 channel plus 3 aux channels = 35
		-- 8 RHA x 35 channels = 280 samples = 4480 bits
		-- Plus a 31bit header = 4511 bits = 564 bytes (rounded up)
		-- This results in upto 41 x 14byte blocks = 574 bytes. 
		COMPONENT FIFO
		PORT (
			rst : IN STD_LOGIC;
			wr_clk : IN STD_LOGIC;
			rd_clk : IN STD_LOGIC;
			din : IN STD_LOGIC_VECTOR(7 DOWNTO 0);
			wr_en : IN STD_LOGIC;
			rd_en : IN STD_LOGIC;
			dout : OUT STD_LOGIC_VECTOR(7 DOWNTO 0);
			full : OUT STD_LOGIC;
			empty : OUT STD_LOGIC;
			prog_full : OUT STD_LOGIC;
			prog_empty : OUT STD_LOGIC
		);
		END COMPONENT;
	
		signal FIFO_AFULL : STD_LOGIC := '0';
		signal FIFO_AEMPTY : STD_LOGIC := '0';
		signal FIFO_EMPTY : STD_LOGIC := '0';
		signal FIFO_FULL : STD_LOGIC := '0';
		-- Domain Crossing! 
		signal FIFO_IN_READENABLE_DX : STD_LOGIC := '0';
		signal FIFO_IN_READENABLE_LAST  : STD_LOGIC := '0';
		signal dout : STD_LOGIC_VECTOR(7 DOWNTO 0) := (others => '0');


		-- Decouple 
		signal din_DECOUPLE  : STD_LOGIC_VECTOR(7 DOWNTO 0) := (others => '0');
		signal wr_en_DECOUPLE  : STD_LOGIC := '0';
		signal rd_en_DECOUPLE  : STD_LOGIC := '0';
		signal dout_DECOUPLE  : STD_LOGIC_VECTOR(7 DOWNTO 0) := (others => '0');
		signal full_DECOUPLE  : STD_LOGIC := '0';
		signal empty_DECOUPLE  : STD_LOGIC := '0';
		signal prog_full_DECOUPLE  : STD_LOGIC := '0';
		signal prog_empty_DECOUPLE  : STD_LOGIC := '0';
		
		-- DEBUG ZARLINK COMMUNICATION
		signal DEBUG_ZARLINK_DATA_INTERNAL		: STD_LOGIC_VECTOR(15 downto 0) := (others => '0');
		signal DEBUG_ZARLINK_VALID_INTERNAL		: STD_LOGIC := '0';
		signal DEBUG_COUNTER							: unsigned (3 downto 0) := (others => '0');
	
		signal SPI_ZL_CS_BUFFER	: STD_LOGIC := '0';
		signal SPI_SDI_BUFFER	: STD_LOGIC := '0';
		signal SPI_CLK_BUFFER	: STD_LOGIC := '0';

		constant HeaderByte_1					: std_logic_vector(7 downto 0) := "00110000"; -- 48
		constant HeaderByte_2					: std_logic_vector(7 downto 0) := "01101001"; -- 105
		constant Implant_ID     				: std_logic_vector(7 downto 0) := "00110101"; -- Implant ID 53
		constant Command_RHD_COMMAND 			: std_logic_vector(7 downto 0) := "10101010";
		constant Command_Channel				: std_logic_vector(7 downto 0) := "10101011";
		constant Command_Aux						: std_logic_vector(7 downto 0) := "10001010";
		constant Command_TestMode				: std_logic_vector(7 downto 0) := "10101110"; 
		constant Command_WORKMODE				: std_logic_vector(7 downto 0) := "10111010";
		constant Command_SampleRate  			: std_logic_vector(7 downto 0) := "11101010";
		constant Command_BITMASK 				: std_logic_vector(7 downto 0) := "00101010";

		-- In the case we don't need the debug stuff, then we route them to unused ports... 
		-- Debugging the Zarlink 
		signal DEBUG_ZARLINK_DATA		: STD_LOGIC_VECTOR(15 downto 0);
		signal DEBUG_ZARLINK_VALID		: STD_LOGIC;

		-- DEBUG
		signal DEBUG_GetCommand_DATA		: STD_LOGIC_VECTOR(7 downto 0);
		signal DEBUG_GetCommand_VALID		: STD_LOGIC;		

		-- Parameters
		signal DEBUG_ChannelMask_00   			: std_logic_vector( 31 downto 0);
		signal DEBUG_ChannelMask_01   			: std_logic_vector( 31 downto 0);
		signal DEBUG_ChannelMask_02   			: std_logic_vector( 31 downto 0);
		signal DEBUG_ChannelMask_03   			: std_logic_vector( 31 downto 0);
		signal DEBUG_ChannelMask_04   			: std_logic_vector( 31 downto 0);
		signal DEBUG_ChannelMask_05   			: std_logic_vector( 31 downto 0);
		signal DEBUG_ChannelMask_06   			: std_logic_vector( 31 downto 0);
		signal DEBUG_ChannelMask_07   			: std_logic_vector( 31 downto 0);
		signal DEBUG_ChannelMask_Changed		: std_logic;
		signal DEBUG_AuxMask_00					: std_logic_vector( 2 downto 0);
		signal DEBUG_AuxMask_01					: std_logic_vector( 2 downto 0);
		signal DEBUG_AuxMask_02					: std_logic_vector( 2 downto 0);
		signal DEBUG_AuxMask_03					: std_logic_vector( 2 downto 0);
		signal DEBUG_AuxMask_04					: std_logic_vector( 2 downto 0);
		signal DEBUG_AuxMask_05					: std_logic_vector( 2 downto 0);
		signal DEBUG_AuxMask_06					: std_logic_vector( 2 downto 0);
		signal DEBUG_AuxMask_07					: std_logic_vector( 2 downto 0);
		signal DEBUG_AuxMask_Changed			: std_logic;
		signal DEBUG_RHD_COMMAND_DATA 			: std_logic_vector( 15 downto 0);
		signal DEBUG_RHD_COMMAND_VALID 			: std_logic_vector(7 downto 0);		
		signal DEBUG_SampleRate      			: std_logic_vector(31 downto 0);
		signal DEBUG_SampleRate_Changed			: std_logic;
		signal DEBUG_TestMode						: STD_LOGIC;
		signal DEBUG_TestMode_Changed			: STD_LOGIC;
		signal DEBUG_WorkMode						: STD_LOGIC;
		signal DEBUG_WorkMode_Changed			: STD_LOGIC;
		signal DEBUG_BITMASK_SAMPLE				: std_logic_vector(15 downto 0);			 
		signal DEBUG_BITMASK_SAMPLE_Changed		: std_logic;		

		signal DEBUG_FIFO_OUT_DATA 				: std_logic_vector(7 downto 0);
		signal DEBUG_FIFO_OUT_VALID 			: STD_LOGIC;

		signal DEBUG_FIFO_ZL_DATA 				: std_logic_vector(7 downto 0);
		
		signal DEBUG_CheckOutgoingBuffer 		: std_logic_vector (6 downto 0);		
		
		signal DEBUG_FIFO_ZL_VALID 				: STD_LOGIC;

		signal Clk 								: std_logic := '0';
		signal Clock_4MHz 						: STD_LOGIC := '0';
		signal Counter_4MHz 					: unsigned(1 downto 0) := (others => '0');

		
begin
	-- DEBUG ZARLINK COMMUNICATION
	DEBUG_ZARLINK_DATA <= DEBUG_ZARLINK_DATA_INTERNAL;
	DEBUG_ZARLINK_VALID <= DEBUG_ZARLINK_VALID_INTERNAL;

	SPI_ZL_CS <= SPI_ZL_CS_BUFFER;
	SPI_SDI <= SPI_SDI_BUFFER;
	SPI_CLK <= SPI_CLK_BUFFER;

		DEBUG_ChannelMask_00 <= ChannelMask_00;
		DEBUG_ChannelMask_01 <= ChannelMask_01;
		DEBUG_ChannelMask_02 <= ChannelMask_02;
		DEBUG_ChannelMask_03 <= ChannelMask_03;
		DEBUG_ChannelMask_04 <= ChannelMask_04;
		DEBUG_ChannelMask_05 <= ChannelMask_05;
		DEBUG_ChannelMask_06 <= ChannelMask_06;
		DEBUG_ChannelMask_07 <= ChannelMask_07;
		DEBUG_ChannelMask_Changed <= ChannelMask_Changed;
		DEBUG_AuxMask_00 <= AuxMask_00;
		DEBUG_AuxMask_01 <= AuxMask_01;
		DEBUG_AuxMask_02 <= AuxMask_02;
		DEBUG_AuxMask_03 <= AuxMask_03;
		DEBUG_AuxMask_04 <= AuxMask_04;
		DEBUG_AuxMask_05 <= AuxMask_05;
		DEBUG_AuxMask_06 <= AuxMask_06; 
		DEBUG_AuxMask_07 <= AuxMask_07;
		DEBUG_AuxMask_Changed <= AuxMask_Changed;
		DEBUG_RHD_COMMAND_DATA <= RHD_COMMAND_DATA;
		DEBUG_RHD_COMMAND_VALID <= RHD_COMMAND_VALID;
		DEBUG_SampleRate <= SampleRate;
		DEBUG_SampleRate_Changed <= SampleRate_Changed;
		DEBUG_TestMode <= TestMode;
		DEBUG_TestMode_Changed <= TestMode_Changed;
		DEBUG_WorkMode <= WorkMode;
		DEBUG_WorkMode_Changed <= WorkMode_Changed;
		DEBUG_BITMASK_SAMPLE <= BITMASK_SAMPLE;
		DEBUG_BITMASK_SAMPLE_Changed	<= BITMASK_SAMPLE_Changed;

	NOTWorkMode <= NOT WorkMode;
	-- Xilinx FIFO Version 
	MyFIFO : FIFO
	PORT MAP (
		rst => Reset,
		wr_clk => Clk,
		rd_clk => Clk,
		din => din_DECOUPLE,
		wr_en => wr_en_DECOUPLE,
		rd_en => rd_en_DECOUPLE,
		dout => dout_DECOUPLE,
		full => full_DECOUPLE,
		empty => empty_DECOUPLE,
		prog_full => prog_full_DECOUPLE, 
		prog_empty => prog_empty_DECOUPLE
	);

	DECOUPLE_FIFO : process (Reset,Clk)
	begin
		if Reset = '1' then
			-- Reset 
			din_DECOUPLE <= (others => '0');
			wr_en_DECOUPLE <= '0';

			dout <= (others => '0');
			rd_en_DECOUPLE <= '0';

			FIFO_AFULL <= '1';
			FIFO_FULL <= '1';

			FIFO_AEMPTY <= '1';
			FIFO_EMPTY <= '1';

		elsif rising_edge(Clk) then

			-- din_DECOUPLE <= "01010101";
			din_DECOUPLE <= FIFO_OUT_DATA;
			wr_en_DECOUPLE <= FIFO_OUT_VALID;

			dout <= dout_DECOUPLE;
			rd_en_DECOUPLE <= FIFO_IN_READENABLE_DX;

			FIFO_AFULL <= prog_full_DECOUPLE;
			FIFO_FULL <= full_DECOUPLE;

			FIFO_AEMPTY <= prog_empty_DECOUPLE;
			FIFO_EMPTY <= empty_DECOUPLE;
		end if;
	end process DECOUPLE_FIFO;		



	DEBUG_FIFO_OUT_DATA <= FIFO_OUT_DATA;
	DEBUG_FIFO_OUT_VALID <= FIFO_OUT_VALID;

	DEBUG_FIFO_ZL_DATA <= dout;
	DEBUG_FIFO_ZL_VALID <= FIFO_IN_READENABLE_DX;

	-- We need to reverse the bit order otherwise the results is in the wrong order...
	FIFO_IN_DATA(7) <= dout(0);
	FIFO_IN_DATA(6) <= dout(1);
	FIFO_IN_DATA(5) <= dout(2);
	FIFO_IN_DATA(4) <= dout(3);
	FIFO_IN_DATA(3) <= dout(4);
	FIFO_IN_DATA(2) <= dout(5);
	FIFO_IN_DATA(1) <= dout(6);
	FIFO_IN_DATA(0) <= dout(7);
	
	-- If there is still space then '1'
	ExportNext280ChannelBlock <= NOT FIFO_AFULL;
	-- If there is are at least 14 x 8 bit left, be a '1'
	FIFO_IN_VALID <= NOT FIFO_AEMPTY;

	-- We need to cross the read signal from the 
	-- slow Zarlink module to the fast fifo.
	WR_EN_FIFO : process (Clk,Reset)
	begin
		if Reset = '1' then
			FIFO_IN_READENABLE_DX <= '0';
		elsif rising_edge(Clk) then
			FIFO_IN_READENABLE_DX <= '0';
			FIFO_IN_READENABLE_LAST <= FIFO_IN_READENABLE;
			
			if (FIFO_IN_READENABLE_LAST = '0') AND (FIFO_IN_READENABLE = '1') then
				FIFO_IN_READENABLE_DX <= '1';
			else
				null;
			end if;
		
		end if;
	end process WR_EN_FIFO;		

	ZL_DEBUG : process (SPI_CLK_BUFFER,SPI_ZL_CS_BUFFER)
	begin
		if SPI_ZL_CS_BUFFER = '1' then
			DEBUG_ZARLINK_DATA_INTERNAL <= (others => '0');
			DEBUG_ZARLINK_VALID_INTERNAL <= '0';
			DEBUG_COUNTER <= (others => '0');
		elsif rising_edge(SPI_CLK_BUFFER) then
			
			if DEBUG_COUNTER = to_unsigned(7,4) then
				DEBUG_ZARLINK_VALID_INTERNAL <= '1';
				DEBUG_COUNTER <= (others => '0');
				DEBUG_ZARLINK_DATA_INTERNAL(7 downto 0) <= DEBUG_ZARLINK_DATA_INTERNAL(6 downto 0) & SPI_SDO;
				DEBUG_ZARLINK_DATA_INTERNAL(15 downto 8) <= DEBUG_ZARLINK_DATA_INTERNAL(14 downto 8) & SPI_SDI_BUFFER;
			else
				DEBUG_ZARLINK_VALID_INTERNAL <= '0';
				DEBUG_COUNTER <= DEBUG_COUNTER + 1;
				DEBUG_ZARLINK_DATA_INTERNAL(7 downto 0) <= DEBUG_ZARLINK_DATA_INTERNAL(6 downto 0) & SPI_SDO;
				DEBUG_ZARLINK_DATA_INTERNAL(15 downto 8) <= DEBUG_ZARLINK_DATA_INTERNAL(14 downto 8) & SPI_SDI_BUFFER;
			end if;
		
		end if;
	end process ZL_DEBUG;		
	
	Inst_CONTROL_NEXUS: entity work.CONTROL_NEXUS 
	PORT MAP(
		SPI_ZL_CS => SPI_ZL_CS_BUFFER,
		SPI_SDI => SPI_SDI_BUFFER,
		SPI_SDO => SPI_SDO,
		SPI_CLK => SPI_CLK_BUFFER,
		ChannelMask_00 => ChannelMask_00,
		ChannelMask_01 => ChannelMask_01,
		ChannelMask_02 => ChannelMask_02,
		ChannelMask_03 => ChannelMask_03,
		ChannelMask_04 => ChannelMask_04,
		ChannelMask_05 => ChannelMask_05,
		ChannelMask_06 => ChannelMask_06,
		ChannelMask_07 => ChannelMask_07,
		ChannelMask_Changed => ChannelMask_Changed,
		AuxMask_00 => AuxMask_00,
		AuxMask_01 => AuxMask_01,
		AuxMask_02 => AuxMask_02,
		AuxMask_03 => AuxMask_03,
		AuxMask_04 => AuxMask_04,
		AuxMask_05 => AuxMask_05,
		AuxMask_06 => AuxMask_06, 
		AuxMask_07 => AuxMask_07,
		AuxMask_Changed => AuxMask_Changed,
		RHD_COMMAND_DATA => RHD_COMMAND_DATA,
		RHD_COMMAND_VALID => RHD_COMMAND_VALID,
		SampleRate => SampleRate,
		SampleRate_Changed => SampleRate_Changed,
		TestMode => TestMode,
		TestMode_Changed => TestMode_Changed,
		WorkMode => WorkMode,
		WorkMode_Changed => WorkMode_Changed,
		DeviceID => DeviceID,
		BITMASK_SAMPLE => BITMASK_SAMPLE,
		BITMASK_SAMPLE_Changed	=> BITMASK_SAMPLE_Changed,
		WAIT_PROCESS_PARAMETER => WAIT_PROCESS_PARAMETER,
		FIFO_IN_DATA => FIFO_IN_DATA,
		FIFO_IN_VALID => FIFO_IN_VALID,
		FIFO_IN_READENABLE => FIFO_IN_READENABLE,
		HeaderByte_1 => HeaderByte_1,
		HeaderByte_2 => HeaderByte_2,
		Implant_ID => Implant_ID,
		Command_RHD_COMMAND => Command_RHD_COMMAND,
		Command_Channel => Command_Channel,
		Command_Aux => Command_Aux,
		Command_TestMode => Command_TestMode,
		Command_WORKMODE => Command_WORKMODE,
		Command_SampleRate => Command_SampleRate,
		Command_BITMASK => Command_BITMASK,
		DEBUG_GetCommand_DATA => DEBUG_GetCommand_DATA,
		DEBUG_GetCommand_VALID => DEBUG_GetCommand_VALID,
		DEBUG_CheckOutgoingBuffer => DEBUG_CheckOutgoingBuffer,
--		DEBUG_STRING_ORGANIZER => DEBUG_STRING_ORGANIZER,
--		DEBUG_ProcessOngoing => DEBUG_ProcessOngoing,
--		DEBUG_ProcessParameter => DEBUG_ProcessParameter,
		Clock_4MHz => Clock_4MHz,
		Reset => Reset,
		Clk => Clk
	);

	Inst_DATA_ACQUISITION_BLOCK: entity work.DATA_ACQUISITION_BLOCK 
	PORT MAP(
		RHD_MOSI_OUTSIDE => RHD_MOSI,
		RHD_MISO_OUTSIDE	=> RHD_MISO,
		RHD_Clk_OUTSIDE => RHD_Clk,
		RHD_CS_OUTSIDE => RHD_CS,
		FIFO_OUT_DATA => FIFO_OUT_DATA,
		FIFO_OUT_VALID => FIFO_OUT_VALID,
		ExportNext280ChannelBlock => ExportNext280ChannelBlock,
		ChannelMask_00 => ChannelMask_00,
		ChannelMask_01 => ChannelMask_01,
		ChannelMask_02 => ChannelMask_02,
		ChannelMask_03 => ChannelMask_03,
		ChannelMask_04 => ChannelMask_04,
		ChannelMask_05 => ChannelMask_05,
		ChannelMask_06 => ChannelMask_06,
		ChannelMask_07 => ChannelMask_07,
		ChannelMask_Changed => ChannelMask_Changed,
		AuxMask_00 => AuxMask_00,
		AuxMask_01 => AuxMask_01,
		AuxMask_02 => AuxMask_02,
		AuxMask_03 => AuxMask_03,
		AuxMask_04 => AuxMask_04,
		AuxMask_05 => AuxMask_05,
		AuxMask_06 => AuxMask_06, 
		AuxMask_07 => AuxMask_07,
		AuxMask_Changed => AuxMask_Changed,
		RHD_COMMAND_DATA => RHD_COMMAND_DATA,
		RHD_COMMAND_VALID => RHD_COMMAND_VALID,
		SampleRate => SampleRate,
		SampleRate_Changed => SampleRate_Changed,
		TestMode => TestMode,
		TestMode_Changed => TestMode_Changed,
		WorkMode => WorkMode,
		WorkMode_Changed => WorkMode_Changed,
		DeviceID => DeviceID,
		BITMASK_SAMPLE => BITMASK_SAMPLE,
		BITMASK_SAMPLE_Changed	=> BITMASK_SAMPLE_Changed,
		WAIT_PROCESS_PARAMETER => WAIT_PROCESS_PARAMETER,
		ERROR_ALL_OUT => ERROR_ALL_OUT,
		Command_RHD_COMMAND => Command_RHD_COMMAND,
		Command_Channel => Command_Channel,
		Command_Aux => Command_Aux,
		Command_TestMode => Command_TestMode,
		Command_WORKMODE => Command_WORKMODE,
		Command_SampleRate => Command_SampleRate,
		Command_BITMASK => Command_BITMASK,
		Reset => Reset,
		Clk => Clk
	);

   -- We reduce the 24 MHz to a 4 MHz clock
   CLK_4MHZ_PROCESS : process (Reset,Clk_FAST)
   begin
       if Reset = '1' then
           Counter_4MHz <= to_unsigned(0,2);
           Clock_4MHz <= '0';
       elsif rising_edge(Clk_FAST) then
           Clock_4MHz <= Clock_4MHz;
           Counter_4MHz <= Counter_4MHz;
           if std_logic_vector(Counter_4MHz) = "10" then
               Clock_4MHz <= NOT Clock_4MHz; 
               Counter_4MHz <= to_unsigned(0,2);
           else
               Counter_4MHz <= Counter_4MHz + 1;
           end if;
       end if;
   end process CLK_4MHZ_PROCESS;

	CLK_2 : process (Clk_FAST,Reset)
	begin
		if Reset = '1' then
			Clk <= '0';
		elsif rising_edge(Clk_FAST) then
			Clk <= NOT Clk;
		end if;
	end process CLK_2;


end architecture Behavioral;

