-- Written by David Rotermund (davrot@neuro.uni-bremen.de)
-- University of Bremen, Institute for theoretical physiscs
-- (Use Atom.IO editor for correct indents)

-- The RHD test generator is connected to all 8 data analyzers...

-- Version 0.0 (23.07.14) : Original source code was written
-- Version 0.1 (03.07.15) : Added debug info, reformating with Atom.IO

library IEEE;

use IEEE.std_logic_1164.all;
use IEEE.numeric_std.all;

entity RHD_TESTMODULE is
  Port (
    RHD_MOSI_OUTSIDE            :  in STD_LOGIC_VECTOR (7 downto 0);
    RHD_MISO_OUTSIDE            : out STD_LOGIC_VECTOR (7 downto 0);
    RHD_Clk_OUTSIDE             :  in STD_LOGIC_VECTOR (7 downto 0);
    RHD_CS_OUTSIDE              :  in STD_LOGIC_VECTOR (7 downto 0);
    TEST_INFO                   :  in  STD_LOGIC;

    -- DEBUG SECTION
    DEBUG_S_RHDTES_FSM0_STATE   : out std_logic_vector(4 downto 0);
    DEBUG_S_RHDTES_FSM1_STATE   : out std_logic_vector(4 downto 0);

    Clk                         :  in STD_LOGIC;
    Reset                       :  in STD_LOGIC
  );
end RHD_TESTMODULE;

architecture Behavioral of RHD_TESTMODULE is
  signal RHD_MISO : std_logic := '0';

begin
  -- All are the same!!!! Because we drive them with the same input signals.
  -- Thus we can safe a lot of space if we only implement one test module!!!

  RHD_MISO_OUTSIDE <= RHD_MISO & RHD_MISO & RHD_MISO & RHD_MISO &
  RHD_MISO & RHD_MISO & RHD_MISO & RHD_MISO;

  RHD_TEST_MOD_0: entity work.RHD_TEST_MODULATOR
  Port MAP (
    -- For the data stream
    RHD_MOSI_OUTSIDE => RHD_MOSI_OUTSIDE(0),
    RHD_MISO_OUTSIDE => RHD_MISO,
    RHD_Clk_OUTSIDE => RHD_Clk_OUTSIDE(0),
    RHD_CS_OUTSIDE => RHD_CS_OUTSIDE(0),
    TEST_INFO => TEST_INFO,
    DEBUG_M_FSM0_STATE => DEBUG_S_RHDTES_FSM0_STATE,
    DEBUG_M_FSM1_STATE => DEBUG_S_RHDTES_FSM1_STATE,
    Clk => Clk,
    Reset => Reset
  );


end Behavioral;
