# Tested under SL6.5
# Note about the actual status of the system:
# Identified problems:
# 1.) Several 100 samples are recorded then there is one break, the number of collected sample ID jumps up (first row in the ASICData.dat) and works fine again without further problems
# 2.) Sometimes a command is not accepted. We can see this in the response (only 0 or only the command ID without the RHD response or we don't get any reponse). 
#     ./tool_debug 192.168.1.100 1 1 delivers the communcation between the Zarlink and the base station Zarlink.dat file. 
# 3.) We get a set of 0 in the beginning before any command was submitted. 
# 4.) The implant FPGA used only 12 MHz instead of 24MHz. This limits the sample rate to ~ 12KSample per second. 
# 5.) Somehow there are the responses from the basestation missing or coming too late. However it still works... - Solved!
# 6.) Tests with more channels and RHDs are necessary. A tests was sucessfully conducted with RHD0 and its channel 0. Surprises are possible... 

# Notes about the ASICData.dat files (Results from the data acquisition) 
# First row: sample ID, generated by the implant
# Second row: Timer ID of the basestation  
# Third row: First 16 Trigger channels on the base station
# ***** : Data 
# Last Row: Should be 1 or there is problem

# Notes about Basisstation.dat: Collect messages from the base station
# Notes about IMP_Response.dat: Collects the communication from the implant as response to commands 

#echo "Programm basestation"
#./tool_programming 192.168.1.100 Basestation.bit
./tool_programming 192.168.1.100 Base_Test.bit
# We need these sleeps because the network stack is used strangely. Every tools need to "time out" its network connection before the next command is processed.
sleep 1s

echo "Reset Zarlink on basestation"
./tool_writereg 192.168.1.100 95 82
sleep 1s

echo "Active IMPLANT"
sleep 10s

echo "Create connection between basestation and implant"
./tool_init 192.168.1.100
sleep 1s

echo "Check if the basestation is connected to the implant (in many cases 45, which is okay)"
 ./tool_readreg 192.168.1.100 50 ; cat Basisstation.dat
sleep 1s

echo "Setting the parameter on the basestation for decoding the package"
# We expect only one channel in the data (otherwise increase 1 to the number of expected channels, can also be larger...)
./tool_recparameter 192.168.1.100 65535 1 9
sleep 1s

echo "Set sample rate"
# This parameter sets the time between two samples 
# One sample takes around 27 clock cycles 
# There are 36 "channels" per RHD (32 analog channels, 3 aux channels and a virtual command channel to the RHD)
# The different RHDs are processed in parallel 
# Actually the RHD core runs with 12MHz
# Sample Rate = 12 * 10^6 / ((27 + n) * 36) with n which is set by this function
./tool_writeblock 192.168.1.100 48 105 53 234 0 0 0 250 0 0 0 0 0 0
sleep 1s

echo "Enable test mode"
./tool_writeblock 192.168.1.100 48 105 53 174 1 0 0 0 0 0 0 0 0 0
sleep 1s


###########################################################
## Test for installed RHD0
#echo "Reg 0"
## 10 dec2bin(0,6) & 11011110
#./tool_writeblock 192.168.1.100 48 105 53 170 1 128 222 0 0 0 0 0 0 0
#sleep 1s 

#echo "Reg 1"
## 10 dec2bin(1,6) &  00000010
#./tool_writeblock 192.168.1.100 48 105 53 170 1 129 2 0 0 0 0 0 0 0 
#sleep 1s 

#echo "Reg 2"
## 10 dec2bin(2,6) &  00000100
#./tool_writeblock 192.168.1.100 48 105 53 170 1 130 4 0 0 0 0 0 0 0
#sleep 1s 

#echo "Reg 3"
## 10 dec2bin(3,6) &  00000000
#./tool_writeblock 192.168.1.100 48 105 53 170 1 131 0 0 0 0 0 0 0 0
#sleep 1s 

#echo "Reg 4"
## 10 dec2bin(4,6) &  10000000
#./tool_writeblock 192.168.1.100 48 105 53 170 1 132 128 0 0 0 0 0 0 0
#sleep 1s 

#echo "Reg 5"
## 10 dec2bin(5,6) &  00000000
#./tool_writeblock 192.168.1.100 48 105 53 170 1 133 0 0 0 0 0 0 0 0
#sleep 1s 

#echo "Reg 6"
## 10 dec2bin(6,6) &  00000000
#./tool_writeblock 192.168.1.100 48 105 53 170 1 134 0 0 0 0 0 0 0 0
#sleep 1s 

#echo "Reg 7"
## 10 dec2bin(7,6) &  00000000
#./tool_writeblock 192.168.1.100 48 105 53 170 1 135 0 0 0 0 0 0 0 0
#sleep 1s 

###################################### Bandpass 250Hz and 1Hz

#echo "Reg 8"
##10 dec2bin(8,6) & 00101010 
#./tool_writeblock 192.168.1.100 48 105 53 170 1 136 42 0 0 0 0 0 0 0
#sleep 1s 

#echo "Reg 9"
##10 dec2bin(9,6) & 10001010 
#./tool_writeblock 192.168.1.100 48 105 53 170 1 137 138 0 0 0 0 0 0 0
#sleep 1s 

#echo "Reg 10"
##10 dec2bin(10,6) & 00000101
#./tool_writeblock 192.168.1.100 48 105 53 170 1 138 5 0 0 0 0 0 0 0
#sleep 1s 

#echo "Reg 11"
##10 dec2bin(11,6) & 10001101
#./tool_writeblock 192.168.1.100 48 105 53 170 1 139 141 0 0 0 0 0 0 0
#sleep 1s 

#echo "Reg 12"
##10 dec2bin(12,6) & 00101100
#./tool_writeblock 192.168.1.100 48 105 53 170 1 140 44 0 0 0 0 0 0 0 
#sleep 1s 

#echo "Reg 13"
##10 dec2bin(13,6) & 10000110
#./tool_writeblock 192.168.1.100 48 105 53 170 1 141 134 0 0 0 0 0 0 0 
#sleep 1s 

########################### Enable the channels

#echo "Reg 14" 
## 10 dec2bin(14,6) & 11111111
# ./tool_writeblock 192.168.1.100 48 105 53 170 1 142 255 0 0 0 0 0 0 0
#sleep 1s 

#echo "Reg 15"
## 10 dec2bin(15,6) & 11111111
# ./tool_writeblock 192.168.1.100 48 105 53 170 1 143 255 0 0 0 0 0 0 0
#sleep 1s 

#echo "Reg 16"
## 10 dec2bin(16,6) & 11111111
# ./tool_writeblock 192.168.1.100 48 105 53 170 1 144 255 0 0 0 0 0 0 0
#sleep 1s 

#echo "Reg 17"
## 10 dec2bin(17,6) & 11111111
# ./tool_writeblock 192.168.1.100 48 105 53 170 1 145 255 0 0 0 0 0 0 0
#sleep 1s 

#echo "Calibrate RHD"
# ./tool_writeblock 192.168.1.100 48 105 53 170 1 85 0 0 0 0 0 0 0 0
#sleep 1s 


###################################
# Channel MASK
###################################
echo "Channel Mask RH0"
# "0 1" means activate Channel 0 of RHD0
# "0 255 255 255 255" would acticate all 32 channels of the RHD0
# However even there is only 1 channel active, a minimum of 14bytes are used per sample
# The first 31 bits are a header, up to 16 bits are used for the data and the rest is 
# filled with zeros. If more the 5 channels are active a second block of 14 byte per sample is 
# added (only a 1 bit header). And so on...
# With a maximum of up to 500kBit per second over the Zarlink connection 
# we can transmitt up to ~ 4400 blocks per second. 
./tool_writeblock 192.168.1.100 48 105 53 171 0 1 0 0 0 0 0 0 0 0
sleep 1s
##################################

echo "Set bitmask for decoding the acquired data"
./tool_writeblock 192.168.1.100 48 105 53 42 255 255 0 0 0 0 0 0 0 0
sleep 1s

echo "Activate recording"
./tool_writeblock 192.168.1.100 48 105 53 186 1 0 0 0 0 0 0 0 0 0
sleep 1s

echo "Wait 10 sec"
sleep 4s


echo "./tool_dataread 192.168.1.100 "
./tool_dataread 192.168.1.100 


# Some notes:
# ------------------------

# Info about the Zarlink Connection Flag:

# Zarlink Register 50: 
#Interrupt group 2 raw source status:
#   Provides the status of the raw interrupt sources (group 2)
#   before enable masking
#[6] - irq_txbuffoverflow, transmit buffer overflow flag
#[5] - irq_linkquality, link poor quality flag
#[4] - irq_radiofail, radio fail flag
#[3] - irq_radioready, radio ready flag
#[2] - irq_linkready, link ready flag
#[1] - irq_hkmessreg, incoming housekeeping register read or
#   write flag
#[0] - irq_commanddone, command done flag

# Reading out other stuff from the RHD

#echo "Ask the number of the channels for all possible 8 RHDs"
#./tool_writeblock 192.168.1.100 48 105 53 170 255 254 0 0 0 0 0 0 0 0

#echo "Ask for the INTAN Tech Chip ID"
#./tool_writeblock 192.168.1.100 48 105 53 170 255 255 0 0 0 0 0 0 0 0

#echo "Ask for the Die Revision"
#./tool_writeblock 192.168.1.100 48 105 53 170 255 252 0 0 0 0 0 0 0 0

# Register: 40 (I)
# ./tool_writeblock 192.168.1.100 48 105 53 170 1 232 0 0 0 0 0 0 0 0
#10010010 | 01001001  ("36 0 0 171")
# Register: 41 (N)
# ./tool_writeblock 192.168.1.100 48 105 53 170 1 233 0 0 0 0 0 0 0 0
#01110010 | 01001110  ("228 0 0 170")
# Register: 42 (T)
# ./tool_writeblock 192.168.1.100 48 105 53 170 1 234 0 0 0 0 0 0 0 0
#00101010 | 01010100  ("84 0 0 170")
# Register: 43 (A)
# ./tool_writeblock 192.168.1.100 48 105 53 170 1 235 0 0 0 0 0 0 0 0
#10000010 | 01000001  ("4 0 0 171")
# Register: 44 (N)
# ./tool_writeblock 192.168.1.100 48 105 53 170 1 236 0 0 0 0 0 0 0 0
#01110010 | 01001110  ("228 0 0 170")

# Setting the AUX mask
#echo "Aux Mask RH0"
#./tool_writeblock 192.168.1.100 48 105 53 138 0 0 0 0 0 0 0 0 0 0
